



(*
 * caseL : 'a -> 'b * ('b list -> 'a) -> 'b list -> 'a
 * REQUIRES: true
 * ENSURES: caseL b f [] =~ b 
 *  and caseL b f x::xs =~ f (x, xs)
 *)
fun caseL (b:'a) (f:'b * 'b list -> 'a) (lst:'b list) : 'a =
  (case lst of
      [] => b
    | x::xs => f (x, xs)
  ) 
  